﻿Imports System.Threading
Imports System.Drawing.Drawing2D
Public Class Form1
    Dim Chip8 As New Chip_8
    Private gl As Thread
    Dim isActive As Boolean = False
    Dim count As Integer = 0

    Private Sub Form1_FormClosing(sender As Object, e As FormClosingEventArgs) Handles Me.FormClosing
        gl.Abort()
        While gl.IsAlive
            gl.Abort()
        End While
    End Sub

    Private Sub Form1_KeyDown(sender As Object, e As KeyEventArgs) Handles Me.KeyDown$
        If e.KeyCode = Keys.D1 Then Chip8.KEY(&H1) = 1
        If e.KeyCode = Keys.D2 Then Chip8.KEY(&H2) = 1
        If e.KeyCode = Keys.D3 Then Chip8.KEY(&H3) = 1
        If e.KeyCode = Keys.D4 Then Chip8.KEY(&HC) = 1
        If e.KeyCode = Keys.Q Then Chip8.KEY(&H4) = 1
        If e.KeyCode = Keys.W Then Chip8.KEY(&H5) = 1
        If e.KeyCode = Keys.E Then Chip8.KEY(&H6) = 1
        If e.KeyCode = Keys.R Then Chip8.KEY(&HD) = 1
        If e.KeyCode = Keys.A Then Chip8.KEY(&H7) = 1
        If e.KeyCode = Keys.S Then Chip8.KEY(&H8) = 1
        If e.KeyCode = Keys.D Then Chip8.KEY(&H9) = 1
        If e.KeyCode = Keys.F Then Chip8.KEY(&HE) = 1
        If e.KeyCode = Keys.Y Then Chip8.KEY(&HA) = 1
        If e.KeyCode = Keys.X Then Chip8.KEY(&H0) = 1
        If e.KeyCode = Keys.C Then Chip8.KEY(&HB) = 1
        If e.KeyCode = Keys.V Then Chip8.KEY(&HF) = 1
        If e.KeyCode = Keys.Escape Then Application.Exit()
        If e.KeyCode = Keys.F1 Then MsgBox("Ein kleiner Chip8-Interpreter." & vbCrLf & "Angezeigt werden die V-Register(Datenregister)," & vbCrLf & "den StackPointer & der Stack und" & vbCrLf & "Der 4k-Speicher. Weitere Register:" & vbCrLf & "PC: ProgramCounter, IR: IndexRegister" & vbCrLf & "OC: OpCode, DT: DelayTimer" & vbCrLf & "BT: BeepTimer" & vbCrLf & "Die Tasten:" & vbCrLf & "1234" & vbCrLf & "QWER" & vbCrLf & "ASDF" & vbCrLf & "YXCV")
    End Sub

    Private Sub Form1_KeyUp(sender As Object, e As KeyEventArgs) Handles Me.KeyUp
        If e.KeyCode = Keys.D1 Then Chip8.KEY(&H1) = 0
        If e.KeyCode = Keys.D2 Then Chip8.KEY(&H2) = 0
        If e.KeyCode = Keys.D3 Then Chip8.KEY(&H3) = 0
        If e.KeyCode = Keys.D4 Then Chip8.KEY(&HC) = 0
        If e.KeyCode = Keys.Q Then Chip8.KEY(&H4) = 0
        If e.KeyCode = Keys.W Then Chip8.KEY(&H5) = 0
        If e.KeyCode = Keys.E Then Chip8.KEY(&H6) = 0
        If e.KeyCode = Keys.R Then Chip8.KEY(&HD) = 0
        If e.KeyCode = Keys.A Then Chip8.KEY(&H7) = 0
        If e.KeyCode = Keys.S Then Chip8.KEY(&H8) = 0
        If e.KeyCode = Keys.D Then Chip8.KEY(&H9) = 0
        If e.KeyCode = Keys.F Then Chip8.KEY(&HE) = 0
        If e.KeyCode = Keys.Y Then Chip8.KEY(&HA) = 0
        If e.KeyCode = Keys.X Then Chip8.KEY(&H0) = 0
        If e.KeyCode = Keys.C Then Chip8.KEY(&HB) = 0
        If e.KeyCode = Keys.V Then Chip8.KEY(&HF) = 0
    End Sub

    Private Sub Form1_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        Dim osVer As Version = Environment.OSVersion.Version
        If osVer.Major = 5 Then
            MsgBox("Alles was älter als Windows Vista ist wird nicht unterstützt.")
            Application.Exit()
        End If
        DebugRegister_mt()
        Me.KeyPreview = True
        gl = New Thread(AddressOf GameLoop)
        gl.IsBackground = True
        gl.Start()
    End Sub

    Public Sub Draw()
        Dim bmp As New Bitmap(64, 32, Imaging.PixelFormat.Format24bppRgb)
        For y As Integer = 0 To 31
            For x As Integer = 0 To 63
                If Chip8.screen((y * 64) + x) = 0 Then
                    bmp.SetPixel(x, y, Color.Black)
                Else
                    bmp.SetPixel(x, y, Color.White)
                End If
            Next
        Next
        Invoke(Sub() PixelBox1.Image = bmp)
    End Sub



    Private Sub GameLoop()
        While True
            If isActive = True Then
                Call Chip8.emucyc()
                count += 1
                If Chip8.updatescreen = True Then
                    Chip8.updatescreen = False
                    Draw()
                End If
                If CheckBox1.Checked = True Then
                    If InvokeRequired Then
                        DebugRegister_mt()
                    Else
                        DebugRegister_mt()
                    End If
                End If
                If Not Debugger.IsAttached = True Then
                    Dim delay As Integer = CInt(NumericUpDown1.Value)
                    While (Not delay = 0)
                        delay -= 1
                    End While
                End If
            End If
        End While
    End Sub

    Public Sub DebugRegister_mt()
        Invoke(Sub() ListView1.Groups.Clear())
        Invoke(Sub() ListView1.Items.Clear())
        Invoke(Sub() ListView2.Items.Clear())
        Invoke(Sub() ListView1.Groups.Add(New ListViewGroup("Data Register", HorizontalAlignment.Left)))
        Invoke(Sub() ListView1.Groups.Add(New ListViewGroup("Stack", HorizontalAlignment.Left)))
        Invoke(Sub() ListView1.Groups.Add(New ListViewGroup("Other Registers", HorizontalAlignment.Left)))
        For i As Integer = 0 To 16
            Dim x As Integer = i
            Invoke(Sub() ListView1.Items.Add(New ListViewItem(New String() {"V-" & x.ToString("X"), "0x" & Chip8.V(x).ToString("X2")})).Group = ListView1.Groups(0))
        Next
        Invoke(Sub() ListView1.Items.Add(New ListViewItem(New String() {"StackPointer", "0x" & Chip8.SP.ToString("X2")})).Group = ListView1.Groups(1))
        For i As Integer = 0 To 16
            Dim x As Integer = i
            Invoke(Sub() ListView1.Items.Add(New ListViewItem(New String() {"Stack-" & x.ToString("X"), "0x" & Chip8.stack(x).ToString("X2")})).Group = ListView1.Groups(1))
        Next
        For i As Integer = 0 To 511
            Dim x As Integer = i
            Invoke(Sub() ListView2.Items.Add(New ListViewItem(New String() {"0x" & (x * 8).ToString("X3") & "-0x" & ((x * 8) + 8).ToString("X3"), "0x" & Chip8.memory(x * 8).ToString("X2") & "-0x" & Chip8.memory((x * 8) + 1).ToString("X2") & "-0x" & Chip8.memory((x * 8) + 2).ToString("X2") & "-0x" & Chip8.memory((x * 8) + 3).ToString("X2") & "-0x" & Chip8.memory((x * 8) + 4).ToString("X2") & "-0x" & Chip8.memory((x * 8) + 5).ToString("X2") & "-0x" & Chip8.memory((x * 8) + 6).ToString("X2") & "-0x" & Chip8.memory((x * 8) + 7).ToString("X2")})))
        Next
        Invoke(Sub() Label1.Text = "PC: 0x" & Chip8.PC.ToString("X3"))
        Invoke(Sub() Label2.Text = "IR: 0x" & Chip8.IR.ToString("X3"))
        Invoke(Sub() Label3.Text = "OC: 0x" & Chip8.inst.ToString("X3"))
        Invoke(Sub() Label4.Text = "DT: 0x" & Chip8.delay_timer.ToString("X2"))
        Invoke(Sub() Label5.Text = "BT: 0x" & Chip8.beep_timer.ToString("X2"))
    End Sub

    Private Sub Button1_Click(sender As Object, e As EventArgs) Handles Button1.Click
        Call Chip8.init()
    End Sub

    Private Sub Button3_Click(sender As Object, e As EventArgs) Handles Button3.Click
        Call Chip8.emucyc()
        DebugRegister_mt()
        count += 1
        If Chip8.updatescreen = True Then
            Draw()
            Chip8.updatescreen = False
        End If
    End Sub

    Private Sub Button4_Click(sender As Object, e As EventArgs) Handles Button4.Click
        isActive = True
    End Sub

    Private Sub Button5_Click(sender As Object, e As EventArgs) Handles Button5.Click
        isActive = False
        DebugRegister_mt()
    End Sub

    Private Sub Button2_Click(sender As Object, e As EventArgs) Handles Button2.Click
        Dim ofd As New OpenFileDialog
        ofd.InitialDirectory = My.Computer.FileSystem.CurrentDirectory
        ofd.Filter = "Chip-8 Games (*.c8)|*.c8"
        ofd.FilterIndex = 1
        If ofd.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            Debug.Print(ofd.FileName)
            Select Case (Chip8.LoadChip8(ofd.FileName))
                Case 0

                Case 1
                    MsgBox("Ungültiger Pfad")
                    Return
                Case 2
                    MsgBox("Dateigrösse ungültig")
                    Return
            End Select
        End If
        DebugRegister_mt()
    End Sub
End Class